package com.cours.entities;

import java.io.Serializable;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.xml.bind.annotation.XmlRootElement;



@Entity
@Table(name = "Adresse")
@XmlRootElement
public class Adresse implements Serializable, Comparable<Adresse> {
	private static final long serialVersionUID = -5648141250241976386L;
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Basic(optional = false)
	@Column(name = "idAdresse")
	private Integer idAdresse;
	@Column(name = "rue")
	private String rue;
	@Column(name = "codePostal")
	private String codePostal;
	@Column(name = "ville")
	private String ville;
	@Column(name = "pays")
	private String pays;
	
	@ManyToOne
	@JoinTable(name = "Personne_Adresse_Associations",
	            joinColumns = @JoinColumn(name = "idAdresse"),
	            inverseJoinColumns = @JoinColumn(name = "idPersonne"))
    private Personne personne;
	 
	@Column(name = "version")
	@Version
	private Integer version;
	public Adresse() {

	}

	public Adresse(String rue, String ville, String codePostal, String pays) {
		this.rue = rue;
		this.codePostal = codePostal;
		this.ville = ville;
		this.pays = pays;
	}

	public Adresse(Integer idAdresse, String rue, String ville, String codePostal, String pays) {
		this.idAdresse = idAdresse;
		this.rue = rue;
		this.codePostal = codePostal;
		this.ville = ville;
		this.pays = pays;
	}

	public Integer getIdAdresse() {
		return idAdresse;
	}

	public void setIdAdresse(Integer idAdresse) {
		this.idAdresse = idAdresse;
	}

	public String getRue() {
		return rue;
	}

	public void setRue(String rue) {
		this.rue = rue;
	}

	public String getVille() {
		return ville;
	}

	public void setVille(String ville) {
		this.ville = ville;
	}

	public String getCodePostal() {
		return codePostal;
	}

	public void setCodePostal(String codePostal) {
		this.codePostal = codePostal;
	}

	public String getPays() {
		return pays;
	}

	public void setPays(String pays) {
		this.pays = pays;
	}
	
	public Personne getPersonne() {
		return personne;
	}

	@Override
	public String toString() {
		return String.format("[idAdresse=%s, rue=%s,  ville=%s, codePostal=%s, pays=%s]", idAdresse, rue, ville,
				codePostal, pays);
	}

	@Override
	public int hashCode() {
		int prime = 31;
		int result = 1;
		result = result * prime + this.rue.hashCode();
		result = result * prime + this.ville.hashCode();
		result = result * prime + this.codePostal.hashCode();
		result = result * prime + this.pays.hashCode();
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null || !(obj instanceof Adresse)) {
			return false;
		}
		Adresse otherAdress = (Adresse) obj;
		return (otherAdress.getRue().equals(getRue()) && otherAdress.getVille().equals(getVille())
				&& otherAdress.getCodePostal().equals(getCodePostal()));
	}

	@Override
	public int compareTo(Adresse otherAdresse) {
		return (this.getVille()).compareTo(otherAdresse.getVille());
	}

}
